<?php

namespace App\Jobs;

use App\Models\Order;
use GuzzleHttp\Client;
use App\Models\AccessDetail;
use Illuminate\Bus\Queueable;
use Illuminate\Support\Facades\Log;
use Illuminate\Queue\SerializesModels;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Contracts\Queue\ShouldBeUnique;



class FulfillmentJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct()
    {
        
    }

    /**
     * Execute the job.
     *
     * @return void
     */

     private function createClient($shop, $accessToken)
     {
 
         $baseUri = "https://{$shop}/admin/api/2023-01/";
 
         return new Client([
             'base_uri' => $baseUri,
             'headers' => [
                 'Content-Type' => 'application/json',
                 'X-Shopify-Access-Token' => $accessToken,
             ],
         ]);
     }

    public function handle()
    {
        $fulfillmentRequests = Order::where('fulfillemt_status', 0)->where('status', 1)->where('tracking_number', '==', Null)->where('pickup_status', 'Ready For Pickup')->get();
		
        if ($fulfillmentRequests) {
            foreach ($fulfillmentRequests as $key => $fulfillmentRequest) {
                $access_id=$fulfillmentRequest->access_id;
                $access_details=AccessDetail::find($access_id);
                Log::info($access_details);
                $session=$access_details->sessions;
                Log::info($session);
                $shop =  $session->shop;
				$baseUri = "https://{$shop}/admin/api/2023-01/";
				$accessToken = $session->access_token;

				$client = $this->createClient($baseUri, $accessToken);
                Log::info($client);
                // foreach ($fulfillmentRequest->line_items as $key => $lineItem) {
					
				// 	$fulfillment_order_id = $lineItem->fulfillment_order_id;
				// 	$id = $lineItem->id;
				// 	$quantity = $lineItem->fulfillable_quantity;
				// 	try {
				// 		$response = $client->post('fulfillments.json', [
				// 			'json' => [
				// 				'fulfillment' => [
				// 					'line_items_by_fulfillment_order' => [
				// 						[
				// 							'fulfillment_order_id' => $fulfillment_order_id,
				// 							'fulfillment_order_line_items' => [
				// 								[
				// 									'id' => $id,
				// 									'quantity' => $quantity
				// 								]
				// 							]
				// 						]
				// 					],
				// 					'tracking_info' => [
				// 						'number' => $fulfillmentRequest->tracking_number,
				// 						'url' => $fulfillmentRequest->url,
				// 						// 'company' => $fulfillmentRequest->company, 
				// 					],
				// 					'message' => $fulfillmentRequest->message,
				// 					'notify_customer' => $fulfillmentRequest->notify_customer
				// 				]
				// 			]
				// 		]);

				// 		$statusCode = $response->getStatusCode();
				// 		if ($statusCode >= 200 || $statusCode <= 301) {
				// 			Log::info($statusCode);
				// 			$responseData = json_decode($response->getBody(), true);
				// 			$fulfillmentRequest->process = 1;
				// 			$fulfillmentRequest->save();
				// 		}
				// 	} catch (\Throwable $th) {
				// 		Log::info($th->getMessage());
				// 		$fulfillmentRequest->process_count++;
				// 		$fulfillmentRequest->save();
				// 	}

					
                // }

            }
        }
    }
}
