<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateOrdersTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('orders', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('access_id');
            $table->bigInteger('order_id');
            $table->json('order_data');
            $table->json('return_data');
            $table->text('awb_no');
            $table->text('label');
            $table->text('pickup_status');
            $table->boolean('status')->default(0);
            $table->timestamps();

            $table->foreign('access_id')->references('id')->on('access_details')->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('orders');
    }
}
