<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

class CreateFulfillmentRequestsTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('fulfillment_requests', function (Blueprint $table) {
            $table->id();
            $table->unsignedBigInteger('store_id');
            $table->json('data');
            $table->bigInteger('order_id');
            $table->json('line_items');
            $table->bigInteger('assigned_location_id');
            $table->json('supported_actions');
            $table->string('request_status');
            $table->string('status');
            $table->json('destination');
            $table->json('outgoing_requests');

            $table->string('tracking_number')->nullable();
            $table->string('url')->nullable();
            $table->text('message')->nullable();
            $table->integer('quantity')->nullable();
            $table->boolean('notify_customer')->default(false);
           
            $table->tinyInteger('fulfill_status')->nullable();
           
            $table->timestamps();

            $table->foreign('store_id')
                ->references('id')->on('sessions')->onDelete('cascade');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('fulfillment_requests');
    }
}
